/*
 * libclose.c - loader for library
 *
 * Copyright (C) 2019 Thorsten Otto
 */
#include "slb/tiff.h"
#include <stdio.h>
#include <mint/mintbind.h>
#include <time.h>
#include "libstrct.h"
#include "slbload.h"


static long __CDECL slb_unloaded(SLB_HANDLE slb, long fn, short nwords, ...)
{
	(void)slb;
	(void)fn;
	(void)nwords;
	(void) Cconws(TIFF_SHAREDLIB_NAME " was already unloaded\r\n");
	Pterm(1);
	return -32;
}


void slb_tiff_close(void)
{
	SLB *tiff = slb_tiff_get();

	if (!tiff)
		return;
	if (tiff->handle)
	{
		slb_unload(tiff->handle);
		tiff->handle = 0;
	}
	tiff->exec = slb_unloaded;
}
